searchData={"items":[{"type":"module","title":"DNSSRVCluster","doc":"App functions","ref":"DNSSRVCluster.html"},{"type":"function","title":"DNSSRVCluster.get_pid/0","doc":"Get pid of application worker.","ref":"DNSSRVCluster.html#get_pid/0"},{"type":"function","title":"DNSSRVCluster.list_all_nodes/1","doc":"Get list of all nodes that exist in DNS SRV record.","ref":"DNSSRVCluster.html#list_all_nodes/1"},{"type":"function","title":"DNSSRVCluster.list_connected_nodes/1","doc":"Get list of connected nodes.","ref":"DNSSRVCluster.html#list_connected_nodes/1"},{"type":"function","title":"DNSSRVCluster.list_unconnected_nodes/1","doc":"Get list of nodes that are not connected.","ref":"DNSSRVCluster.html#list_unconnected_nodes/1"},{"type":"module","title":"DNSSRVCluster.Worker","doc":"Main app worker\n\nYou can use it in your own supervision tree if you want.","ref":"DNSSRVCluster.Worker.html"},{"type":"function","title":"DNSSRVCluster.Worker.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DNSSRVCluster.Worker.html#child_spec/1"},{"type":"extras","title":"DNSSRVCluster","doc":"# DNSSRVCluster\n\nElixir clustering with DNS SRV records.","ref":"readme.html"},{"type":"extras","title":"Installation - DNSSRVCluster","doc":"The package can be installed by adding `dns_srv_cluster` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:dns_srv_cluster, \"~> 0.1.0\"}\n  ]\nend\n```\n\nAdd to your DNS zone your SRV record (https://en.wikipedia.org/wiki/SRV_record):\n\n```sh\n_app._tcp.yourdomain.com. 86400 IN SRV 0 10 1234 node1.yourdomain.com.\n_app._tcp.yourdomain.com. 86400 IN SRV 0 10 1234 node2.yourdomain.com.\n_app._tcp.yourdomain.com. 86400 IN SRV 0 10 1234 node3.yourdomain.com.\n_app._tcp.yourdomain.com. 86400 IN SRV 0 10 1234 node4.yourdomain.com.\n```\n\nAdd to your config files (`config/prod.exs`, `config/dev.exs`):\n\n```elixir\nconfig :dns_srv_cluster,\n  query: \"_app._tcp.yourdomain.com\"\n```\n\nAdd this to your `rel/env.sh.eex`:\n\n```sh\nexport RELEASE_DISTRIBUTION=\"${RELEASE_DISTRIBUTION:-\"name\"}\"\nexport RELEASE_NODE=\"${RELEASE_NODE:-\" \"}\"\n```\n\nBy default, nodes from the same release will have the same cookie. If you want different\napplications or releases to connect to each other, then you must set the `RELEASE_COOKIE`,\neither in your deployment platform or inside `rel/env.sh.eex`:\n\n```sh\nexport RELEASE_COOKIE=\"my-app-cookie\"\n```","ref":"readme.html#installation"},{"type":"extras","title":"All configuration options - DNSSRVCluster","doc":"* `query` - your DNS SRV record, for example: \"_app._tcp.yourdomain.com\".\n  * `interval` - the millisec interval between DNS queries. Defaults to `5_000`.\n  * `connect_timeout` - the millisec timeout to allow discovered nodes to connect. Defaults to `10_000`.","ref":"readme.html#all-configuration-options"},{"type":"extras","title":"If you want it in your supervision tree - DNSSRVCluster","doc":"Do in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:dns_srv_cluster, \"~> 0.1.0\", runtime: false}\n  ]\nend\n```\n\n`runtime: false` will block application from starting.\n\nAnd use `DNSSRVCluster.Worker` as a child:\n\n```elixir\nchildren = [\n  {DNSSRVCluster.Worker, query: \"_app._tcp.yourdomain.com\"}\n]\n\n{:ok, pid} = Supervisor.start_link(children, strategy: :one_for_one)\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#if-you-want-it-in-your-supervision-tree"}],"content_type":"text/markdown"}